
Const FPS=90

Graphics3D 800,600,0,2
SetBuffer BackBuffer()

WireFrame False

camera = CreateCamera()
PositionEntity camera,0,10,-50

TOKSIM_CreateSimulator(0,-9,0)

SeedRnd MilliSecs()  


obj = CreateCube()
ab = TOKAB_Create()
TOKAB_AddBox ab,2.0,2.0,2.0
TOKAB_SetPosition ab,0.0,5.0,0
PositionEntity obj,0,5,0 
EntityColor obj,Rnd(100,230),Rnd(100,230),Rnd(100,230) 
 

obj2 = CreateCube()
rb = TOKRB_Create()
TOKRB_CollideConnected rb,True 
TOKRB_AddBox rb,2.0,2.0,2.0
TOKRB_SetPosition rb,0.0,0.0,0.0
TOKRB_SetLinearDamping rb,0.003
TOKRB_SetAngularDamping rb,0.0003
TOKRB_SetMass rb,1.0
TOKRB_SetBoxInertiaTensor rb,2.0,2.0,2.0,1.0 
TOKRB_SetSleepingParameter rb,0.01
EntityColor obj2,Rnd(100,230),Rnd(100,230),Rnd(100,230) 

joint = TOKJOINT_Create(3,rb,ab)
TOKJOINT_SetType joint,4
TOKJOINT_SetPositionAndRotationWorld joint,0.0,0.0,0.0,0,0,0 
TOKJOINT_Enable joint,True 
TOKJOINT_SetLowerLimit joint,-3
TOKJOINT_SetUpperLimit joint,3
TOKJOINT_EnableLimit joint,True 


Centerpivot = CreatePivot()

light=CreateLight()
PositionEntity light,7,15,-5
PointEntity light,Centerpivot
rot#=90

period=1000/FPS
time=MilliSecs()-period

imptime=MilliSecs()
; MainLoop
While Not KeyHit(1)

	Repeat
		elapsed=MilliSecs()-time
	Until elapsed

	ticks=elapsed/period
	tween#=Float(elapsed Mod period)/Float(period)

	For k=1 To ticks
		time=time+period
		If k=ticks Then CaptureWorld

		TOKSIM_Advance(1.5/FPS,1)

camx#=Cos(rot#)*10
camz#=Sin(rot#)*10

If rot#>360 Then rot#=0

PositionEntity camera,camx#,5.0,camz#
PointEntity camera,centerpivot  

 PositionEntity obj2,TOKRB_GetX(rb),TOKRB_GetY(rb),TOKRB_GetZ(rb) 
 RotateEntity obj2,TOKRB_GetPitch(rb),TOKRB_GetYaw(rb),TOKRB_GetRoll(rb),False
	UpdateWorld

	Next

	
If KeyHit(57) Then
  TOKRB_ApplyImpulse rb,0,15,0 
  TOKRB_ApplyTwist rb,0,15,0
EndIf

	RenderWorld tween

Text 0,10,"Render Time:"+Str(elapsed)+ " milliseconds"
	Flip 

Wend

TOKSIM_DestroySimulator()

End